DEAL:
	BCF		INTF1,ADCIF,A
	BCF		INTE1,ADCIE,A
;	BCF		ADCCN1,ENADC,ACCE	;ADC
	BTSS		PT1,BIT6,A			;P_PT1.6q
	JMP		DEALM				;PT1.6lowɬdM21 Table
	CALL		TS_TEMPERATURE		;dpThermopileҷū
	CALL		TSV_VOLTAGE		;dpThermopileXq
;-----------------------------------------------
;TSV_H|TSV_L + (TP_GAIN * TP_ADX )/100H
;-----------------------------------------------
	CLRF		EBH,A
	CLRF		EBL,A
	MVFF		TP_ADH,BH
	MVFF		TP_ADL,BL
	BTSS		TP_ADH,BIT7,A		;P_Ÿ	
	JMP		NO_INVERT
INVERT:	
	CLRF		STATUS,A
	COMF		BL,F,A
	COMF		BH,F,A
	INSZ		BL,F,A
	JMP		NO_INVERT
	INF		BH,F,A
;-------- TP_GAIN * TP_ADX ----------
NO_INVERT:
	CLRF		EAH,A
	MVFF		TP_GAINH,EAL
	MVFF		TP_GAINM,AH
	MVFF		TP_GAINL,AL
	CALL		32BITMUL32BITU	;EAH|EAL|AH|AL * EBH|EBL|BH|BL ==> EBH|EBL|BH|BL|EAH|EAL|AH|AL
	CALL		EBX_EDX
	CALL		EAX_EBX
	CALL		EDX_EAX
;------- TP_GAIN * TP_ADX/100 ---------
	CLRF		ECH
	CLRF		ECL
	MVL		01H
	MVF		CH,F,A
	MVL		00H
	MVF		CL,F,A
	CLRF		EGH
	CLRF		EGL
	MVL		01H
	MVF		GH,F,A
	MVL		00H
	MVF		GL,F,A
	CALL		64bitdiv32bitu	;EAH|EAL|AH|AL|EBH|EBL|BH|BL / ECH|ECL|CH|CL ==> EBH|EBL|BH|BL|EAH|EAL|AH|AL
	CALL		64DIV32INF		;|ˤJ
	MVFF		AH,BH
	MVFF		AL,BL
;----- TSV_H|TSV_L +(-) TP_GAIN * TP_ADX/100 -----
	MVFF		TSV_H,AH
	MVFF		TSV_L,AL
	BTSS		TP_ADH,BIT7,A
	JMP		POSITIVE
NEGATIVE:
	CALL		16SUB16
	JMP		TSV_OUT
POSITIVE:
	CALL		16ADD16
TSV_OUT:
	MVFF		AH,TPV_H
	MVFF		AL,TPV_L
;------------ INDEX*4 --------------	
	MVFF		TPV_H,AH
	MVFF		TPV_L,AL
	BCF		STATUS,C,ACCE
	RLFC		AL,F,ACCE
	RLFC		AH,F,ACCE
	BCF		STATUS,C,ACCE
	RLFC		AL,F,ACCE
	RLFC		AH,F,ACCE
;------------ INDEX*8 --------------
	BCF		STATUS,C,ACCE
	RLFC		AH,F,ACCE
;----------- DIFFERENCE/4 -----------
	MVFF		AH,BUF_H			;INDEX
	MVFF		AL,BUF_L			;DIFFERENCE=BUF_L/4
	RRF		BUF_L,F,A			;DIFFERENCE/2
	RRF		BUF_L,F,A			;DIFFERENCE
;-------------------------------------------------------
;FIND TABLE
;-------------------------------------------------------
WIDE_T:
	MVL		0A8H
	CPSG		BUF_H,ACCE			;P_O_WLTabled
	JMP		KEEP_OUT1			;BUF_H =  000H-014H
	BSF		FLAG,OV_TEMP		;BUF_H >= 014H
	JMP		SHOW_T
KEEP_OUT1:
;----------------------------------------------
;FIND TABLE: T1+(T2-T1)*DIFFERENCE/128
;----------------------------------------------
	MVF		BUF_H,W,ACCE
	MVLP		V2T
	ADDF		TBLPTRL,F,ACCE
	BTSZ		STATUS,C,ACCE
	INF		TBLPTRH,F,ACCE
	TBLR		*				;OUTPUT: TBLDH,TBLDL
	MVFF		TBLDH,T1_M
	MVFF		TBLDL,T1_L
;------------ INDEX+1 ---------------
	INF		BUF_H,F,A
	MVF		BUF_H,W,A
	MVLP		V2T
	ADDF		TBLPTRL,F,ACCE
	BTSZ		STATUS,C,ACCE
	INF		TBLPTRH,F,ACCE
	TBLR		*				;OUTPUT: TBLDH,TBLDL
	MVFF		TBLDH,EAH
	MVFF		TBLDL,T1_H
;------------ INDEX+1 ---------------
	INF		BUF_H,F,A
	MVF		BUF_H,W,A
	MVLP		V2T
	ADDF		TBLPTRL,F,ACCE
	BTSZ		STATUS,C,ACCE
	INF		TBLPTRH,F,ACCE
	TBLR		*				;OUTPUT: TBLDH,TBLDL
	MVFF		TBLDH,T2_M
	MVFF		TBLDL,T2_L
;------------ INDEX+1 ---------------
	INF		BUF_H,F,A
	MVF		BUF_H,W,A
	MVLP		V2T
	ADDF		TBLPTRL,F,ACCE
	BTSZ		STATUS,C,ACCE
	INF		TBLPTRH,F,ACCE
	TBLR		*				;OUTPUT: TBLDH,TBLDL
	MVFF		TBLDH,EAH
	MVFF		TBLDL,T2_H
;------------ (T2-T1) -------------
	CLRF		EAH
	MVFF		T2_H,EAL
	MVFF		T2_M,AH
	MVFF		T2_L,AL
	CLRF		EBH
	MVFF		T1_H,EBL
	MVFF		T1_M,BH
	MVFF		T1_L,BL
	CALL		32SUB32			;EAX|AX - EBX|BX = AX
;--------- (T2-T1)*DIFFERENCE --------
	CLRF		BH
	MVFF		BUF_L,BL		
	CALL		16BITMUL16BITU		;AH|AL * BH|BL ==> EAH|EAL|AH|AL
;------ (T2-T1)*DIFFERENCE / 64 ------
	MVL		000H
	MVF		CH,F,ACCE
	MVL		040H
	MVF		CL,F,ACCE
	MVFF		CH,GH
	MVFF		CL,GL
	CALL		32BITDIV16BITU		;EAH|EAL|AH|AL / CH|CL ==> EAH|EAL|AH|AL....DH|DL
	CALL		32DIV16INF			;P_|ˤJ
;----- T1+(T2-T1)*DIFFERENCE/64 -----
	CLRF		EBH
	MVFF		T1_H,EBL
	MVFF		T1_M,BH
	MVFF		T1_L,BL
	CALL		32ADD32			;EAX|AX + EBX|BX = EAX|AX
	MVL		000H
	MVF		CH,F,A
	MVL		064H
	MVF		CL,F,A
	MVL		000H
	MVF		GH,F,A
	MVL		064H
	MVF		GL,F,A
	CALL		32BITDIV16BITU		;EAH|EAL|AH|AL / CH|CL ==> EAH|EAL|AH|AL....DH|DL
	CALL		32DIV16INF			;P_|ˤJ
	MVFF		AH,TP_H
	MVFF		AL,TP_L			;oؼзū
	
SHOW_T:
	BTSZ		PT1,BIT7,A			;P_PT1.7޸}q
	CALL		COMPENSATE			;Bŷū׸v
	CLRF		EAL
	MVFF		TP_H,AH
	MVFF		TP_L,AL
	CALL		24BITHEXTOBCD		;ؼзūBCDXഫ
	MVFF		AL,LCDTEMP4
	MVFF		AH,LCDTEMP5
	MVFF		EAL,LCDTEMP6
	MVFF		EAH,LCDTEMP7
	CALL		display_TP			;Thermopileq쪺ؼзū

ENDSHOW:
	MVL		006H
	MVF		NET_CNT,F,ACCE
	MVL		007H
	MVF		ADC_CNT,F,ACCE
	CALL		NET_RFZ	
	CALL		CLEAR_EAX
	BCF		FLAG,INTEND,A		;_ȧлxM0
	BCF		INTF1,ADCIF,A
	BSF		INTE1,ADCIE,A
;	BSF		ADCCN1,ENADC,ACCE	;}ADC
	RET

;-----------------------------------
;RS = GAIN1 * RS_ADX / RF_ADX
;-----------------------------------
TS_TEMPERATURE:
	BTSS		PT1,BIT6,A
	JMP		TS_M_TEMPERATURE
	CLRF		EAH,A
	MVFF		TS_GAINH,EAL
	MVFF		TS_GAINM,AH
	MVFF		TS_GAINL,AL
	JMP		TEMOUT
TS_M_TEMPERATURE:
	CLRF		EAH,A
	MVFF		TSM_GAINH,EAL
	MVFF		TSM_GAINM,AH
	MVFF		TSM_GAINL,AL

TEMOUT:
	CLRF		EBH,A
	CLRF		EBL,A
	MVFF		RS_ADH,BH
	MVFF		RS_ADL,BL
	CALL		32BITMUL32BITU		;EAH|EAL|AH|AL * EBH|EBL|BH|BL ==> EBH|EBL|BH|BL|EAH|EAL|AH|AL
	CALL		EBX_EDX
	CALL		EAX_EBX
	CALL		EDX_EAX
	CLRF		ECH,A
	CLRF		ECL,A
	MVFF		RF_ADH,CH
	MVFF		RF_ADL,CL
	CLRF		EGH,A
	CLRF		EGL,A
	MVFF		RF_ADH,GH
	MVFF		RF_ADL,GL
	CALL		64bitdiv32bitu	;EAH|EAL|AH|AL|EBH|EBL|BH|BL / ECH|ECL|CH|CL ==> EBH|EBL|BH|BL|EAH|EAL|AH|AL
	CALL		64DIV32INF			;|ˤJ
	MVFF		AH,RS_H
	MVFF		AL,RS_L			;oThermistorq
;---------------------------------------
;INDEX=5700H-RS_H|RS_L=22272-RS_H|RS_L
;---------------------------------------
	MVL		057H
	MVF		AH,F,ACCE
	MVL		000H
	MVF		AL,F,ACCE
	MVFF		RS_H,BH
	MVFF		RS_L,BL
	CALL		16SUB16			; AX-BX = AX
	MVFF		AH,BUF_H			;INDEX
	MVFF		AL,BUF_L			;DIFFERENCE
;---------------------------------------
;FIND TABLE:T1+(T2-T1)*DIFFERENCE/256
;---------------------------------------
	MVF		BUF_H,W,ACCE
	MVLP		R2T
	ADDF		TBLPTRL,F,ACCE
	BTSZ		STATUS,C,ACCE
	INF		TBLPTRH,F,ACCE
	TBLR		*				;OUTPUT: TBLDH,TBLDL
	MVFF		TBLDH,T1_H
	MVFF		TBLDL,T1_L
;-------------- INDEX+1 ---------------
	INF		BUF_H,W,A
	MVLP		R2T
	ADDF		TBLPTRL,F,ACCE
	BTSZ		STATUS,C,ACCE
	INF		TBLPTRH,F,ACCE
	TBLR		*				;OUTPUT: TBLDH,TBLDL
	MVFF		TBLDH,T2_H
	MVFF		TBLDL,T2_L
;--------------- T2-T1 ----------------
	MVFF		T2_H,AH
	MVFF		T2_L,AL
	MVFF		T1_H,BH
	MVFF		T1_L,BL
	CALL		16SUB16			; AX-BX = AX
;---------- (T2-T1)*DIFFERENCE -----------
	CLRF		BH
	MVFF		BUF_L,BL		
	CALL		16BITMUL16BITU		;AH|AL * BH|BL ==> EAH|EAL|AH|AL
;--------- (T2-T1)*DIFFERENCE/ 256 ----------
	MVL		001H
	MVF		CH,F,ACCE
	MVL		000H
	MVF		CL,F,ACCE
	MVFF		CH,GH
	MVFF		CL,GL				;Odl
	CALL		32BITDIV16BITU		;EAH|EAL|AH|AL / CH|CL ==> EAH|EAL|AH|AL....DH|DL
	CALL		32DIV16INF			;P_|ˤJ
;--------- T1+(T2-T1)*DIFFERENCE/256 ---------
	MVFF		T1_H,BH
	MVFF		T1_L,BL
	CALL		16ADD16			;AH|AL + BH|BL = AH|AL
	MVFF		AH,TS_H
	MVFF		AL,TS_L			;oThermopileҷū
	RET

;---------------------------------------
;TEMPERATURE TO VOLTAGE
;OUTPUT: TSV_H,TSV_L
;---------------------------------------
TSV_VOLTAGE:
;---------- INDEX=TS - 256 ------------
	MVFF		TS_H,AH
	MVFF		TS_L,AL
	MVL		001H
	MVF		BH,F,ACCE
	MVL		000H
	MVF		BL,F,ACCE
	CALL		16SUB16			; AX-BX = AX
;------------ INDEX*4 --------------
	BCF		STATUS,C,A
	RLFC		AL,F,A
	RLFC		AH,F,A
	BCF		STATUS,C,A
	RLFC		AL,F,A
	RLFC		AH,F,A
;----------- DIFFERENCE/4 -----------
	MVFF		AH,BUF_H			;INDEX
	MVFF		AL,BUF_L			;DIFFERENCE=BUF_L/4
	RRF		BUF_L,F,A			;DIFFERENCE/2
	RRF		BUF_L,F,A
;----------- T2V: 00H-4BH -----------
	MVL		04BH
	CPSG		BUF_H,ACCE			;P_O_WLتdH
	JMP		KEEP_VOLTAGE
	BSF		FLAG,OV_TEMP		;pGWLTabledAOV_TEMPлxm1ALCDN|---
	RET
KEEP_VOLTAGE:
;-------------------------------------------
;FIND TABLE: V1+(V2-V1)*DIFFERENCE/64
;-------------------------------------------
	MVF		BUF_H,W,ACCE
	MVLP		T2V
	ADDF		TBLPTRL,F,ACCE
	BTSZ		STATUS,C,ACCE
	INF		TBLPTRH,F,ACCE
	TBLR		*				;OUTPUT: TBLDH,TBLDL
	MVFF		TBLDH,T1_H
	MVFF		TBLDL,T1_L
;------------ INDEX+1 ------------
	INF		BUF_H,W,A
	MVLP		T2V
	ADDF		TBLPTRL,F,ACCE
	BTSZ		STATUS,C,ACCE
	INF		TBLPTRH,F,ACCE
	TBLR		*				;OUTPUT: TBLDH,TBLDL
	MVFF		TBLDH,T2_H
	MVFF		TBLDL,T2_L
;------------ (V2-V1) ------------
	MVFF		T2_H,AH
	MVFF		T2_L,AL
	MVFF		T1_H,BH
	MVFF		T1_L,BL
	CALL		16SUB16			; AX-BX = AX
;---------- (V2-V1)*DIFFERENCE --------
	CLRF		BH
	MVFF		BUF_L,BL		
	CALL		16BITMUL16BITU		;AH|AL * BH|BL ==> EAH|EAL|AH|AL
;-------- (V2-V1)*DIFFERENCE / 64 -------
	MVL		000H
	MVF		CH,F,ACCE
	MVL		040H
	MVF		CL,F,ACCE
	MVFF		CH,GH
	MVFF		CL,GL				;Odl
	CALL		32BITDIV16BITU		;EAH|EAL|AH|AL / CH|CL ==> EAH|EAL|AH|AL....DH|DL
	CALL		32DIV16INF			;P_|ˤJ
;------- V1+(V2-V1)*DIFFERENCE/64 -------
	MVFF		T1_H,BH
	MVFF		T1_L,BL
	CALL		16ADD16			;AH|AL + BH|BL = AH|AL
	MVFF		AH,TSV_H
	MVFF		AL,TSV_L			;do Vout ( Ta, 0XC ^
	RET

DEALM:
	CALL		TS_TEMPERATURE		;dpThermopileҷū
	CALL		TSV_M
;-----------------------------------------------
;TSV_H|TSV_L + (TP_GAIN * TP_ADX )/100H
;-----------------------------------------------
	CLRF		EBH,A
	CLRF		EBL,A
	MVFF		TP_ADH,BH
	MVFF		TP_ADL,BL
	BTSS		TP_ADH,BIT7,A		;P_Ÿ
	JMP		NO_INVERTM
INVERTM:	
	CLRF		STATUS,A
	COMF		BL,F,A
	COMF		BH,F,A
	INSZ		BL,F,A
	JMP		NO_INVERTM
	INF		BH,F,A
;-------- TP_GAIN * TP_ADX ----------
NO_INVERTM:
	CLRF		EAH,A
	MVFF		TPM_GAINH,EAL
	MVFF		TPM_GAINM,AH
	MVFF		TPM_GAINL,AL
	CALL		32BITMUL32BITU	;EAH|EAL|AH|AL * EBH|EBL|BH|BL ==> EBH|EBL|BH|BL|EAH|EAL|AH|AL
	CALL		EBX_EDX
	CALL		EAX_EBX
	CALL		EDX_EAX
;------- TP_GAIN * TP_ADX/100 ---------
	CLRF		ECH
	CLRF		ECL
	MVL		01H
	MVF		CH,F,A
	MVL		00H
	MVF		CL,F,A
	CLRF		EGH
	CLRF		EGL
	MVL		01H
	MVF		GH,F,A
	MVL		00H
	MVF		GL,F,A
	CALL		64bitdiv32bitu	;EAH|EAL|AH|AL|EBH|EBL|BH|BL / ECH|ECL|CH|CL ==> EBH|EBL|BH|BL|EAH|EAL|AH|AL
	CALL		64DIV32INF		;|ˤJ
	MVFF		AH,BH
	MVFF		AL,BL
;----- TSV_H|TSV_L +(-) TP_GAIN * TP_ADX/100 -----
	MVFF		TSV_H,AH
	MVFF		TSV_L,AL
	BTSS		TP_ADH,BIT7,A
	JMP		POSITIVEM
NEGATIVEM:
	CALL		16SUB16
	JMP		TSV_OUTM
POSITIVEM:
	CALL		16ADD16
TSV_OUTM:
	MVFF		AH,TPV_H
	MVFF		AL,TPV_L
;------------ INDEX*4 --------------	
	MVFF		TPV_H,AH
	MVFF		TPV_L,AL
	BCF		STATUS,C,ACCE
	RLFC		AL,F,ACCE
	RLFC		AH,F,ACCE
	BCF		STATUS,C,ACCE
	RLFC		AL,F,ACCE
	RLFC		AH,F,ACCE
;------------ INDEX*8 --------------
	BCF		STATUS,C,ACCE
	RLFC		AH,F,ACCE
;----------- DIFFERENCE/4 -----------
	MVFF		AH,BUF_H			;INDEX
	MVFF		AL,BUF_L			;DIFFERENCE=BUF_L/4
	RRF		BUF_L,F,ACCE		;DIFFERENCE/2
	RRF		BUF_L,F,A			;DIFFERENCE
	;RRF		BUF_L,F,A
;-------------------------------------------------------
;FIND TABLE
;-------------------------------------------------------
WIDE_TM:
	MVL		028H
	CPSG		BUF_H,ACCE			;P_O_WLTabled
	JMP		KEEP_OUTM			;BUF_H =  000H-028H
	BSF		FLAG,OV_TEMP		;BUF_H >= 014H
	JMP		SHOW_T
KEEP_OUTM:
;----------------------------------------------
;FIND TABLE: T1+(T2-T1)*DIFFERENCE/64
;----------------------------------------------
	MVF		BUF_H,W,ACCE
	MVLP		V2TM
	ADDF		TBLPTRL,F,ACCE
	BTSZ		STATUS,C,ACCE
	INF		TBLPTRH,F,ACCE
	TBLR		*				;OUTPUT: TBLDH,TBLDL
	MVFF		TBLDH,T1_M
	MVFF		TBLDL,T1_L
;------------ INDEX+1 ---------------
	INF		BUF_H,F,A
	MVF		BUF_H,W,A
	MVLP		V2TM
	ADDF		TBLPTRL,F,ACCE
	BTSZ		STATUS,C,ACCE
	INF		TBLPTRH,F,ACCE
	TBLR		*				;OUTPUT: TBLDH,TBLDL
	MVFF		TBLDH,EAH
	MVFF		TBLDL,T1_H
;------------ INDEX+1 ---------------
	INF		BUF_H,F,A
	MVF		BUF_H,W,A
	MVLP		V2TM
	ADDF		TBLPTRL,F,ACCE
	BTSZ		STATUS,C,ACCE
	INF		TBLPTRH,F,ACCE
	TBLR		*				;OUTPUT: TBLDH,TBLDL
	MVFF		TBLDH,T2_M
	MVFF		TBLDL,T2_L
;------------ INDEX+1 ---------------
	INF		BUF_H,F,A
	MVF		BUF_H,W,A
	MVLP		V2TM
	ADDF		TBLPTRL,F,ACCE
	BTSZ		STATUS,C,ACCE
	INF		TBLPTRH,F,ACCE
	TBLR		*				;OUTPUT: TBLDH,TBLDL
	MVFF		TBLDH,EAH
	MVFF		TBLDL,T2_H
;------------ (T2-T1) -------------
	CLRF		EAH
	MVFF		T2_H,EAL
	MVFF		T2_M,AH
	MVFF		T2_L,AL
	CLRF		EBH
	MVFF		T1_H,EBL
	MVFF		T1_M,BH
	MVFF		T1_L,BL
	CALL		32SUB32			;EAX|AX - EBX|BX = AX
;--------- (T2-T1)*DIFFERENCE --------
	CLRF		BH
	MVFF		BUF_L,BL		
	CALL		16BITMUL16BITU		;AH|AL * BH|BL ==> EAH|EAL|AH|AL
;------ (T2-T1)*DIFFERENCE / 64 ------
	MVL		000H
	MVF		CH,F,ACCE
	MVL		040H
	MVF		CL,F,ACCE
	MVFF		CH,GH
	MVFF		CL,GL
	CALL		32BITDIV16BITU		;EAH|EAL|AH|AL / CH|CL ==> EAH|EAL|AH|AL....DH|DL
	CALL		32DIV16INF			;P_|ˤJ
;----- T1+(T2-T1)*DIFFERENCE/64 -----
	CLRF		EBH
	MVFF		T1_H,EBL
	MVFF		T1_M,BH
	MVFF		T1_L,BL
	CALL		32ADD32			;EAX|AX + EBX|BX = EAX|AX
	MVL		000H
	MVF		CH,F,A
	MVL		064H
	MVF		CL,F,A
	MVL		000H
	MVF		GH,F,A
	MVL		064H
	MVF		GL,F,A
	CALL		32BITDIV16BITU		;EAH|EAL|AH|AL / CH|CL ==> EAH|EAL|AH|AL....DH|DL
	CALL		32DIV16INF			;P_|ˤJ
	MVFF		AH,TP_H
	MVFF		AL,TP_L			;oؼзū
	JMP		SHOW_T

TSV_M:
;---------- INDEX=TS - 256 ------------
	MVFF		TS_H,AH
	MVFF		TS_L,AL
	MVL		001H
	MVF		BH,F,ACCE
	MVL		000H

	MVF		BL,F,ACCE
	CALL		16SUB16			; AX-BX = AX
;------------ INDEX*4 --------------
	BCF		STATUS,C,ACCE
	RLFC		AL,F,ACCE
	RLFC		AH,F,ACCE
	BCF		STATUS,C,ACCE
	RLFC		AL,F,ACCE
	RLFC		AH,F,ACCE
;----------- DIFFERENCE/4 -----------
	MVFF		AH,BUF_H			;INDEX
	MVFF		AL,BUF_L			;DIFFERENCE=BUF_L
	RRF		BUF_L,F,ACCE		;DIFFERENCE
	RRF		BUF_L,F,ACCE		;DIFFERENCE
;----------- T2VM: 00H-4AH -----------
	MVL		04AH
	CPSG		BUF_H,ACCE			;P_O_WLتdH
	JMP		KEEP_VOLTAGEM
	BSF		FLAG,OV_TEMP		;pGWLTabledAOV_TEMPлxm1ALCDN|---
	RET
KEEP_VOLTAGEM:
;-------------------------------------------
;FIND TABLE: V1+(V2-V1)*DIFFERENCE/64
;-------------------------------------------
	MVF		BUF_H,W,ACCE
	MVLP		T2VM
	ADDF		TBLPTRL,F,ACCE
	BTSZ		STATUS,C,ACCE
	INF		TBLPTRH,F,ACCE
	TBLR		*				;OUTPUT: TBLDH,TBLDL
	MVFF		TBLDH,T1_H
	MVFF		TBLDL,T1_L
;------------ INDEX+1 ------------
	INF		BUF_H,W,A
	MVLP		T2VM
	ADDF		TBLPTRL,F,ACCE
	BTSZ		STATUS,C,ACCE
	INF		TBLPTRH,F,ACCE
	TBLR		*				;OUTPUT: TBLDH,TBLDL
	MVFF		TBLDH,T2_H
	MVFF		TBLDL,T2_L
;------------ (V2-V1) ------------
	MVFF		T2_H,AH
	MVFF		T2_L,AL
	MVFF		T1_H,BH
	MVFF		T1_L,BL
	CALL		16SUB16			; AX-BX = AX
;---------- (V2-V1)*DIFFERENCE --------
	CLRF		BH
	MVFF		BUF_L,BL		
	CALL		16BITMUL16BITU		;AH|AL * BH|BL ==> EAH|EAL|AH|AL
;-------- (V2-V1)*DIFFERENCE / 64 -------
	MVL		000H
	MVF		CH,F,ACCE
	MVL		040H
	MVF		CL,F,ACCE
	MVFF		CH,GH
	MVFF		CL,GL				;Odl
	CALL		32BITDIV16BITU		;EAH|EAL|AH|AL / CH|CL ==> EAH|EAL|AH|AL....DH|DL
	CALL		32DIV16INF			;P_|ˤJ
;------- V1+(V2-V1)*DIFFERENCE/64 -------
	MVFF		T1_H,BH
	MVFF		T1_L,BL
	CALL		16ADD16			;AH|AL + BH|BL = AH|AL
	MVFF		AH,TSV_H
	MVFF		AL,TSV_L			;do Vout ( Ta, 0XC ^
	RET