Initial:
	MVL		00000001B
	MVF		MCKCN1,F,A			;Internal OSC: HAO
	MVL		00000001B
	MVF		MCKCN2,F,A			;CPU_CK: HS_DCK
	MVL		00001101B
	MVF		MCKCN3,F,A			;Select clock source = HS_DCK/32/32
	MVL		11110000B
	MVF		PWRCN,F,A			;VDDA=2.4V, ACM=1.2V
	CALL		Delay_5ms			;VDDAíw
	
	LBSR		01H				;ewq϶
;------------------Clear RAM---------------------
	LDPR		080H,0
	MVL		080H
CLEARRAM0:
	CLRF		POINC0,A
	DCSZ		WREG,F,A
	JMP		CLEARRAM0
	LDPR		100H,0
	MVL		080H
CLEARRAM1:
	CLRF		POINC0,A
	DCSZ		WREG,F,A
	JMP		CLEARRAM1
;--------------------Set I/O----------------------
	MVL		00000000B
	MVF		TRISC1,F,A
	MVL		00000000B
	MVF		PT1,F,A
	MVL		00000000B
	MVF		PT1DA,F,A
	MVL		11111111B
	MVF		PT1PU,F,A
	MVL		00000000B
	MVF		PT1M1,F,A
	MVL		00000000B
	MVF		PT1M2,F,A
	
	MVL		00000000B
	MVF		TRISC2,F,A
	MVL		00000000B
	MVF		PT2,F,A
	MVL		11010011B
	MVF		PT2PU,F,A
	MVL		00000000B
	MVF		PT2M1,F,A
	MVL		00000000B
	MVF		PT2M2,F,A
;-----------------Set SD18----------------
	MVL		00000000B	
	MVF		ADCCN1,F,ACCE		;PGA GAIN:LPGAj,AD GAIN:1/4
	MVL		00001100B	
	MVF		ADCCN2,F,ACCE		;VREGN:1/2,DCSET[2:0]:
	MVL		10100000B
	MVF		ADCCN3,F,ACCE		;OSR[2:0]:8192
;----------------Set LCD------------------
	CALL		Clear_LCD			;Clear LCD
	CALL		Delay_LCD
	MVL		11011100B
	MVF		LCDCN1,F,A			;VLCDѴ͡AVLCD=3.05VA1/3
	MVL		01100000B
	MVF		LCDCN2,F,A			;1/4 duty
;---------------Read EEPROM----------------
	;EEPROM 00H ==> TS_GAINL
	;EEPROM 01H ==> TS_GAINM
	;EEPROM 02H ==> TS_GAINH
	;EEPROM 03H ==> TS_5A
	;EEPROM 04H ==> TP_GAINL
	;EEPROM 05H ==> TP_GAINM
	;EEPROM 06H ==> TP_GAINH
	;EEPROM 07H ==> TP_5A
	MVL		00H
	MVF		EEADDRESS,F,A
	MVL		08H
	MVF		S_REG_EE,F,A
	MVL		0A0H
	MVF		EECNT,F,A
	LDPR		000H,FSR0
	MVL		TS_GAINL
	CALL		EERDBLK			;IsŪXl{
	
;------------ Read EEPROM -------------
	;EEPROM 08H ==> TSM_GAINL
	;EEPROM 09H ==> TSM_GAINM
	;EEPROM 0AH ==> TSM_GAINH
	;EEPROM 0BH ==> TSM_5A
	;EEPROM 0CH ==> TPM_GAINL
	;EEPROM 0DH ==> TPM_GAINM
	;EEPROM 0EH ==> TPM_GAINH
	;EEPROM 0FH ==> TPM_5A
	MVL		08H
	MVF		EEADDRESS,F,A
	MVL		08H
	MVF		S_REG_EE,F,A
	MVL		0A0H
	MVF		EECNT,F,A
	LDPR		000H,FSR0
	MVL		TSM_GAINL
	CALL		EERDBLK			;IsŪXl{
	
	MVL		5AH
	CPSE		TS_5A,A			;P_ThermistorO_gLե
	BSF		FLAG,NO_CAL,A		;ThermistorSgLեANO_CALлxm1
	MVL		5AH
	CPSE		TP_5A,A			;P_ThermopileO_gLե
	BSF		FLAG,NO_CAL,A		;ThermopileSgLեANO_CALлxm1
	MVL		5AH
	CPSE		TSM_5A,A
	BSF		FLAG,NO_CALM,A		;Thermistorݭnե2
	MVL		5AH
	CPSE		TPM_5A,A
	BSF		FLAG,NO_CALM,A		;Thermopile M21pSgLեANO_CALлxm1
	
;------------ Read EEPROM -------------
	;EEPROM 10H ==> REG1
	;EEPROM 11H ==> REG2
	;EEPROM 12H ==> REG3
	;EEPROM 13H ==> REG4
	;EEPROM 14H ==> REG5
	;EEPROM 15H ==> REG6
	;EEPROM 16H ==> REG7
	;EEPROM 17H ==> REG8
	;EEPROM 18H ==> REG9
	;EEPROM 19H ==> REGA
	;EEPROM 1AH ==> REGB
	;EEPROM 1BH ==> ROT  iHbgJvȮɰgJP_
	MVL		10H
	MVF		EEADDRESS,F,A
	MVL		0CH
	MVF		S_REG_EE,F,A
	MVL		0A0H
	MVF		EECNT,F,A
	LDPR		000H,FSR0
	MVL		REG1
	CALL		EERDBLK			;IsŪXl{

	MVL		07H
	MVF		ADC_CNT,F,A		;ADC˱2A4
	MVL		06H
	MVF		NET_CNT,F,A		;ADCq
	MVL		32H
	MVF		HOLDMODE,F,A
	
	CALL		NET_RFZ			;qThermistorqqѦҹqJqDoffset

	MVL		01000010B
	MVF		INTE1,F,A			;}ADC_лxA}PT1.1_лx
	BSF		INTE1,GIE,A		;}Ҥ_
	BSF		ADCCN1,ENADC,A		;}ADC