INDF0			EQU		00H
POINC0		EQU		01H
PODEC0		EQU		02H
PRINC0		EQU		03H
PLUSW0		EQU		04H
INDF1			EQU		05H
POINC1		EQU		06H
PODEC1		EQU		07H
PRINC1		EQU		08H
PLUSW1		EQU		09H
FSR0H			EQU		0FH
FSR0L			EQU		10H
FSR1H			EQU		11H
FSR1L			EQU		12H
TOSH			EQU		16H
TOSL			EQU		17H
STKPTR		EQU		18H
	STKFL		EQU	7
	STKUN		EQU	6
	STKOV		EQU	5
PCLATH		EQU		1AH
PCLATL		EQU		1BH
TBLPTRH		EQU		1DH
TBLPTRL		EQU		1EH
TBLDH			EQU		1FH
TBLDL			EQU		20H
PRODH			EQU		21H
PRODL			EQU		22H
INTE1			EQU		23H
	GIE		EQU	7
	ADCIE		EQU	6
	TMCIE		EQU	5
	TMBIE		EQU	4
	TMAIE		EQU	3
	WDTIE		EQU	2
	E1IE		EQU	1
	E0IE		EQU	0
INTE2			EQU		24H
	TXIE		EQU	7
	RCIE		EQU	6
	SSPIE		EQU	2
	CCP1IE	EQU	1
	CCP0IE	EQU	0
INTF1			EQU		26H
	ADCIF		EQU	6
	TMCIF		EQU	5
	TMBIF		EQU	4
	TMAIF		EQU	3
	WDTIF		EQU	2
	E1IF		EQU	1
	E0IF		EQU	0
INTF2			EQU		27H
	SSPIF		EQU	2
	CCP1IF	EQU	1
	CCP0IF	EQU	0
WREG			EQU		29H
BSRCN			EQU		2AH
STATUS		EQU		2BH
	C		EQU	4
	DC		EQU	3
	N		EQU	2
	OV		EQU	1
	Z		EQU	0
PSTATUS		EQU		2CH
	PD		EQU	7
	TO		EQU	6
	IDLEB		EQU	5
	BOR		EQU	4
	SKERR		EQU	2
LVDCN			EQU		2DH
	LVDFG		EQU	6
	LVD		EQU	5
	LVDON		EQU	4
PWRCN			EQU		30H
	ENVDDA	EQU	7
	ENACM		EQU	4
MCKCN1		EQU		31H
MCKCN2		EQU		32H
MCKCN3		EQU		33H
OPCN1			EQU		37H
ADCRH			EQU		39H
ADCRM			EQU		3AH
ADCRL			EQU		3BH
ADCCN1		EQU		3CH
	ENADC		EQU	7
ADCCN2		EQU		3DH
ADCCN3		EQU		3EH
AINET1		EQU		3FH
AINET2		EQU		40H
TMACN			EQU		41H
	ENTMA		EQU	7
	TMACK		EQU	6
	ENWDT		EQU	3
TMAR			EQU		42H
TMBCN			EQU		43H
	ENTMB		EQU	7
	TMBCK		EQU	6
	TMBSYC	EQU	3
	TMBR2R	EQU	2
TMBRH			EQU		44H
TMBRL			EQU		45H
TMCCN			EQU		46H
	ENTMC		EQU	7
PRC			EQU		47H
TMCR			EQU		48H
CCPCN			EQU		49H
CCP0RH		EQU		4AH
CCP0RL		EQU		4BH
CCP1RH		EQU		4CH
CCP1RL		EQU		4DH
PASC			EQU		4EH
	PASF		EQU	7
PWMCN			EQU		4FH
	ENPWM		EQU	7
	ENPFD		EQU	6
PWMR			EQU		51H
LCDCN1		EQU		52H
	ENLCD		EQU	7
	LCDPR		EQU	6
	LCDBF		EQU	3
LCDCN2		EQU		53H
	LCDBL		EQU	7
LCD0			EQU		54H
LCD1			EQU		55H
LCD2			EQU		56H
LCD3			EQU		57H
LCD4			EQU		58H
LCD5			EQU		59H
LCD6			EQU		5AH
LCD7			EQU		5BH
LCD8			EQU		5CH
LCD9			EQU		5DH
SSPCON1		EQU		5EH
	SSPEN		EQU	7
	CKP		EQU	6
	CKE		EQU	5
	SMP		EQU	4
SSPSTA		EQU		60H
	SSPBUY	EQU	7
	SSPOV		EQU	6
SSPBUF		EQU		61H
PT1			EQU		6DH
	CAL_PIN	EQU	5
TRISC1		EQU		6EH
PT1DA			EQU		6FH
PT1PU			EQU		70H
PT1M1			EQU		71H
PT1M2			EQU		72H
PT2			EQU		74H
TRISC2		EQU		75H
PT2PU			EQU		77H
PT2M1			EQU		78H
PT2M2			EQU		79H

BIT7			EQU		7
BIT6			EQU		6
BIT5			EQU		5
BIT4			EQU		4
BIT3			EQU		3
BIT2			EQU		2
BIT1			EQU		1
BIT0			EQU		0

A			EQU		0
W			EQU		0
ACCE			EQU		0
F			EQU		1
K			EQU		1
FSR0			EQU		0
FSR1			EQU		1
