;****************************************
;Device:HY11P13
;Calibration:
;****************************************

	include	H08A.asm
	include	Register.asm

	ORG		0000H
	JMP		Main_Pro
	NOP
	ORG		0004H
	include	INT.asm
	
Main_Pro:
	include	Sysini.asm
Main_loop:
	BTSS		PT1,CAL_PIN,A
	JMP		CAL_MODE
	BTSZ		FLAG,INTEND,A		;P__ȬO_
	CALL		DEAL				;_ȧiJƾڳBz
	JMP		KEYSCAN
Main_Rest:
	BTSZ		REST,SL,A
	JMP		SLEEP_MODE			;iJίvҦ
	NOP
	JMP		Main_loop

SLEEP_MODE:
	CALL		CLEAR_LCD
	CALL		Delay_LCD
SLEEP_LOOP:
	BTSS		PT1,BIT0,A
	JMP		SLEEP_LOOP
	
	MVL		02H
	MVF		MCKCN2,F,ACCE
	MVL		00H
	MVF		MCKCN1,F,ACCE
	MVL		00H
	MVF		MCKCN3,F,ACCE

	CLRF		ADCCN1,ACCE
	CLRF		ADCCN2,ACCE
	CLRF		ADCCN3,ACCE
	CLRF		OPCN1,A
	CLRF		LCDCN1,ACCE
	CLRF		PWRCN,ACCE
	MVL		00000000B
	MVF		PT1,F,ACCE
	MVL		00000000B
	MVF		TRISC1,F,ACCE
	MVL		11111111B
	MVF		PT1PU,F,ACCE
	CLRF		PT1M1,ACCE
	CLRF		PT1M2,ACCE			;PT1.X
	CLRF		PT2,ACCE
	MVL		00000000B
	MVF		TRISC2,F,ACCE
	MVL		11111111B
	MVF		PT2PU,F,ACCE		;PT2.X
	BCF		INTF1,E0IF,ACCE
	BSF		INTE1,E0IE,ACCE		;}PT1.0_лx
	SLP
	NOP
	JMP		MAIN_PRO
	
	
	include	ADC.asm
	include	S24CXX.asm
	include	Show.asm
	include	Operation.asm
	include	Cal.asm
	include	Subroution.asm
	include	LCDINX.asm
	include	TABLE.asm
	include	Key.asm
	include	REPAIR.asm